//***************************************************************************
//* LANIOCu wb_t@C
//***************************************************************************

#ifdef EXPORT_DECLSPEC
#define DECLSPEC extern "C" __declspec(dllexport) int __stdcall
#else
#define DECLSPEC extern "C" __declspec(dllimport) int __stdcall
#endif

//***************************************************************************
//* ^`A萔`
//***************************************************************************

//***************************************************************************
//* LANIOnh
//***************************************************************************
#define hLANIO int

//***************************************************************************
//* LALanioGetLastErrorԂG[R[h
//***************************************************************************
enum LANIOERROR {
    LALANIOERR_NOINIT = 1,          //* Ă܂BLALanioInitsĂB
    LALANIOERR_NOLANIO,             //* ʁALANIOł܂łB
    LALANIOERR_NOTEXIST,            //* ŔLANIO葽lw肵܂B
    LALANIOERR_NOTFOUND,            //* w肳ꂽLANIO𔭌ł܂łB
    LALANIOERR_NOCONNECTED,         //* LANIOƐڑĂ܂BLALanioConnectsĂB
    LALANIOERR_INVALIDOPERATION,    //* w肳ꂽ͎sł܂B
    LALANIOERR_ALREADY_CONNECTED,   //* łɐڑĂ܂B
    LALANIOERR_OVERCONNECTMAX,      //* ڑő吔𒴉߂܂B
    LALANIOERR_INVALIDRETURNVALUE,  //* sȖ߂lԂ܂B
};

//***************************************************************************
//* LALanioGetModelŎ擾LANIOf
//***************************************************************************
enum LANIOMODEL {
    NOTLANIO = 0,
    LA2R3A   = 8,
    LA2A3P   = 9,
    LA2R3AV2 = 10,
    LA3A2P   = 11,
    LA5AI    = 12,
    NO_GETMODEL = -1,
};

//***************************************************************************
//* ݒ萔
//***************************************************************************
enum LANIO_AI_RANGE {
    LALANIO_AI_RANGE_100mV          = 0,
    LALANIO_AI_RANGE_1V             = 1,
    LALANIO_AI_RANGE_10V            = 2,
    LALANIO_AI_RANGE_30V            = 3,
    LALANIO_AI_RANGE_20mA_250orm    = 4,
    LALANIO_AI_RANGE_20mA_50orm     = 5,
    LALANIO_AI_RANGE_TC             = 6,
};

enum LALANIO_AI_TRANSMITCYCLE {
    LALANIO_AI_TRANSMITCYCLE_0_05sec = 0,
    LALANIO_AI_TRANSMITCYCLE_0_1sec  = 1,
    LALANIO_AI_TRANSMITCYCLE_0_2sec  = 2,
    LALANIO_AI_TRANSMITCYCLE_0_5sec  = 3,
    LALANIO_AI_TRANSMITCYCLE_1sec    = 4,
    LALANIO_AI_TRANSMITCYCLE_2sec    = 5,
    LALANIO_AI_TRANSMITCYCLE_5sec    = 6,
    LALANIO_AI_TRANSMITCYCLE_10sec   = 7,
    LALANIO_AI_TRANSMITCYCLE_20sec   = 8,
    LALANIO_AI_TRANSMITCYCLE_30sec   = 9,
    LALANIO_AI_TRANSMITCYCLE_1min    = 10,
    LALANIO_AI_TRANSMITCYCLE_2min    = 11,
    LALANIO_AI_TRANSMITCYCLE_5min    = 12,
    LALANIO_AI_TRANSMITCYCLE_10min   = 13,
};

enum LALANIO_AO_RANGE {
    LALANIO_AO_RANGE_10V             = 0,
    LALANIO_AO_RANGE_20mA            = 1,
};

//***************************************************************************
//* AIAG[擾֐
//***************************************************************************

//***************************************************************************
//*     LANIOCu܂B
//***************************************************************************
DECLSPEC LALanioInit();

//***************************************************************************
//*     LANIOCu̎gpI܂B
//***************************************************************************
DECLSPEC LALanioEnd();

//***************************************************************************
//*     OɔG[ԍ擾܂B
//*     ߂l : G[̏Ԃ܂
//***************************************************************************
DECLSPEC LALanioGetLastError();

//***************************************************************************
//* LANIO֐
//***************************************************************************

//***************************************************************************
//*     ILANIOIDModel擾@\ɂĂ̐ݒ܂B
//*        : enable  ̋@\gpꍇTRUE(1)AȂꍇFALSE(0)
//*              port    IDModel擾VÃ|[gԍ
//***************************************************************************
DECLSPEC LALanioSetAutoRequestIdModel(BOOL enable, int port);

//***************************************************************************
//*     LANɂLANIO܂B
//*        : msec    ^CAEgԁiP mbj
//*     ߂l : LANIO̐BłȂꍇ0BG[-1
//***************************************************************************
DECLSPEC LALanioSearch(int msec = 100);

//***************************************************************************
//* LANIO擾֐
//***************************************************************************

//***************************************************************************
//*     LANIOIPAhX擾܂B
//*        : lanio       LANIOԍ
//*              ipaddress   IPAhX擾obt@ւ̃|C^(16byteKv)
//***************************************************************************
DECLSPEC LALanioGetIpAddress(int lanio, char *ipaddress);

//***************************************************************************
//*     LANIOMACAhX擾܂B
//*        : lanio       LANIOԍ
//*              macaddress  MACAhX擾obt@ւ̃|C^(6byteKv)
//***************************************************************************
DECLSPEC LALanioGetMacAddress(int lanio, unsigned char *macaddress);

//***************************************************************************
//*     LANIOIDԍ擾܂B
//*        : lanio   LANIOԍ
//*              id      LANIOID擾obt@ւ̃|C^
//***************************************************************************
DECLSPEC LALanioGetId(int lanio, int *id);

//***************************************************************************
//*     LANIÕf擾܂B
//*        : lanio   LANIOԍ
//*              model   LANIÕf擾obt@ւ̃|C^
//***************************************************************************
DECLSPEC LALanioGetModel(int lanio, int *model);

//***************************************************************************
//*     LANIOɑ΂IDƃfԍ₵܂B
//*        : lanio   LANIOԍ
//*              id      LANIOID擾obt@ւ̃|C^
//*              model   LANIÕf擾obt@ւ̃|C^
//***************************************************************************
DECLSPEC LALanioRequestIdModel(int lanio, int *id, int *model);

//***************************************************************************
//* LANIOڑ֐
//***************************************************************************

//***************************************************************************
//*     LALanioSearchɂĔꂽԂw肵Đڑ܂B
//*        : lanio   LANIOԍ
//*     ߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LALanioConnect(int lanio);

//***************************************************************************
//*     IDƃfw肵Đڑ܂B
//*        : id      LANIOIDԍ
//*              model   LANIÕf
//*     ߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LALanioConnectByIdModel(int id, int model);

//***************************************************************************
//*     IPAhXw肵Đڑ܂B
//*        : ipaddress   IPAhXobt@ւ̃|C^
//*     ߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LALanioConnectByIpAddress(char *ipaddress);

//***************************************************************************
//*     MACAhXw肵Đڑ܂B
//*        : macaddress  MACAhXobt@ւ̃|C^
//*     ߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LALanioConnectByMacAddress(unsigned char *macaddress);

//***************************************************************************
//*     IPAhXURLw肵Đڑ܂B
//*        : address IPAhX܂urlobt@ւ̃|C^
//*              msec    ^CAEgԁiP mbj
//*     ߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LALanioConnectDirect(char *address, int msec = 1000);

//***************************************************************************
//*     IPAhXURLA|[gԍw肵Đڑ܂BڑUDPgp܂B
//*        : address    IPAhX܂urlobt@ւ̃|C^
//*              msec       ^CAEgԁiP mbj
//*              serialport |[gԍ
//*     ߂l : G[-1AILANIOnhԂ܂
//***************************************************************************
DECLSPEC LALanioConnectDirect2(char *address, int msec, int serialport);

//***************************************************************************
//* LANIOؒf֐
//***************************************************************************

//***************************************************************************
//*     LANIOƂ̐ڑؒf܂B
//*        : handle  LANIOnh
//***************************************************************************
DECLSPEC LALanioClose(hLANIO handle);

//***************************************************************************
//* o͊֐
//***************************************************************************

//***************************************************************************
//*     LANIODO𑀍삵܂BSĂDOɑ΂Ăɑ삵܂B
//*        : handle  LANIOnh
//*              signal  DO|[g̐ݒBŉʃrbgDO1ADO2...ɑΉ܂
//***************************************************************************
DECLSPEC LALanioDO(hLANIO handle, int signal);

//***************************************************************************
//*     LANIǑ݂DOԂ擾܂BSĂDOɑ΂ĂɎ擾܂B
//*        : handle  LANIOnh
//*              signal  DO|[g̓eobt@ւ̃|C^
//*                      ŉʃrbgDO1ADO2...
//***************************************************************************
DECLSPEC LALanioGetDO(hLANIO handle, int *signal);

//***************************************************************************
//*     LANIODI擾܂BSĂDIɑ΂ĂɎ擾܂B
//*        : handle  LANIOnh
//*              signal  DI|[g̓eobt@ւ̃|C^
//*                      ŉʃrbgDI1ADI2...
//***************************************************************************
DECLSPEC LALanioDI(hLANIO handle, int *signal);

//***************************************************************************
//*     LANIOAOdo͂܂
//*        : handle  LANIOnh
//*              ch      `lw肵܂B 0:AO1 1:AO2 ...
//*              val     o͒lw肵܂B
//***************************************************************************
DECLSPEC LALanioAOVoltage(hLANIO handle, int ch, int val);

//***************************************************************************
//*     LANIOAOdo͂܂
//*        : handle  LANIOnh
//*              ch      `lw肵܂B 0:AO1 1:AO2 ...
//*              val     o͒lw肵܂B
//***************************************************************************
DECLSPEC LALanioAOAmpere(hLANIO handle, int ch, int val);

//***************************************************************************
//*     LANIOAOdEdo͂܂
//*        : handle   LANIOnh
//*              ch_count o͂`lw肵܂
//*              ch       o͂`lzw肵܂ 0:AO1 1:AO2 ...
//*              range    o͂d/dzw肵܂ 0:d 1:d
//*              val      o͒lw肵܂B
//***************************************************************************
DECLSPEC LALanioAOMulti(hLANIO xport, int ch_count, int *ch, int *range, int *val);

//***************************************************************************
//*     LANIOAȌlݒ肵܂
//*        : handle  LANIOnh
//*              ch      `lw肵܂B 0:AO1 1:AO2 ...
//*              range   d/dw肵܂ 0:d 1:d
//*              val     o͒lw肵܂B
//***************************************************************************
DECLSPEC LALanioSetInitialAO(hLANIO handle, int ch, int range, int val);

//***************************************************************************
//*     LANIOAȌo͒l擾܂
//*        : handle  LANIOnh
//*              ch      `lw肵܂B 0:AO1 1:AO2 ...
//*              range   d/dobt@ւ̃|C^ 0:d 1:d
//*              val     o͒lobt@ւ̃|C^
//***************************************************************************
DECLSPEC LALanioGetAO(hLANIO handle, int ch, int *range, int *val);

//***************************************************************************
//*     LANIOAI͂܂
//*        : handle  LANIOnh
//*              ch      `lw肵܂B 0:AI1 1:AI2 ...
//*              val     ͒lobt@ւ̃|C^
//***************************************************************************
DECLSPEC LALanioAI(hLANIO handle, int ch, int *val);

//***************************************************************************
//*     LANIOAIS`l͂܂
//*        : handle  LANIOnh
//*              val     ͒lobt@ւ̃|C^
//***************************************************************************
DECLSPEC LALanioAIAll(hLANIO handle, int *val);

//***************************************************************************
//*     LANIOAĨWݒ肵܂
//*        : handle  LANIOnh
//*              ch      `lw肵܂B 0:AI1 1:AI2 ...
//*              range   Wݒ
//*                      0:100mV  1:1V  2:10V  3:30V  4:20mA(250)  5:20mA(50)  6:Md
//***************************************************************************
DECLSPEC LALanioSetAIRange(hLANIO handle, int ch, int range);

//***************************************************************************
//*     LANIOAI̐ݒ擾܂
//*        : handle        LANIOnh
//*              ch            `lw肵܂B 0:AI1 1:AI2 ...
//*              range         Wݒ肪obt@ւ̃|C^
//*                            0:100mV  1:1V  2:10V  3:30V  4:20mA(250)  5:20mA(50)  6:Md
//*              transmitcycle ]TCNobt@ւ̃|C^ 
//*                            0:0.05sec  1:0.1sec  2:0.2sec  3:0.5sec
//*                            4:1sec  5:2sec  6:5sec  7:10sec  8:20sec  9:30sec
//*                            10:1min  11:2min  12:5min  13:10min
//***************************************************************************
DECLSPEC LALanioGetAISetting(hLANIO handle, int ch, int *range, int *transmitcycle);

//***************************************************************************
//*     LANIOADRo[^ϊxݒ肵܂
//*        : handle  LANIOnh
//*              speed   ϊx
//*                      0 10sps      1 16.6sps    2 50sps      3 60sps
//*                      4 400sps     5 1200sps    6 3600sps    7 14400sps
//***************************************************************************
DECLSPEC LALanioSetADCsps(hLANIO handle, int speed);

//***************************************************************************
//*     LANIOADRo[^ϊx擾܂
//*        : handle  LANIOnh
//*              speed   ϊxobt@ւ̃|C^
//*                      0 10sps      1 16.6sps    2 50sps      3 60sps
//*                      4 400sps     5 1200sps    6 3600sps    7 14400sps
//***************************************************************************
DECLSPEC LALanioGetADCsps(hLANIO handle, int *speed);

//***************************************************************************
//*     LANIOAI̎]xݒ肵܂
//*        : handle        LANIOnh
//*              transmitcycle ]TCNobt@ւ̃|C^ 
//*                            0:0.05sec  1:0.1sec  2:0.2sec  3:0.5sec
//*                            4:1sec  5:2sec  6:5sec  7:10sec  8:20sec  9:30sec
//*                            10:1min  11:2min  12:5min  13:10min
//***************************************************************************
DECLSPEC LALanioSetCyclicTransmit(hLANIO handle, int transmitcycle);

//***************************************************************************
//*     LANIOAI̎]Jn܂
//*        : handle   LANIOnh
//*              CallBack f[^]R[obN֐
//*              User     R[obN֐Ă΂Ɏwł郆[Uf[^
//***************************************************************************
DECLSPEC LALanioStartCyclicTransmit(hLANIO handle, void *CallBack, void *User);

//***************************************************************************
//*     LANIOAI̎]I܂
//*        : handle   LANIOnh
//***************************************************************************
DECLSPEC LALanioStopCyclicTransmit(hLANIO handle);

//***************************************************************************
//*     LANIOLED_臒lݒ肵܂
//*        : handle  LANIOnh
//*              ch      `lw肵܂B 0:A*1 1:A*2 ...
//*              led     0:w肵͈͓LED_ 1:͈͊OLED_
//*              lthd    臒l
//*              hthd    臒l
//***************************************************************************
DECLSPEC LALanioSetThreshold(hLANIO handle, int ch, int led, int lthd, int hthd);

//***************************************************************************
//*     LANIOLED_臒l擾܂
//*        : handle  LANIOnh
//*              ch      `lw肵܂B 0:A*1 1:A*2 ...
//*              led     0:w肵͈͓LED_ 1:͈͊OLED_
//*              lthd    臒lobt@ւ̃|C^
//*              hthd    臒lobt@ւ̃|C^
//***************************************************************************
DECLSPEC LALanioGetThreshold(hLANIO handle, int ch, int *led, int *lthd, int *hthd);

//***************************************************************************
//*     LANIO̔MdΑݒ肵܂
//*        : handle  LANIOnh
//*              ch      `lw肵܂B 0:AI1 1:AI2 ...
//*              tc_type Md΂̃^Cvw
//*                      0:K 1:J 2:T 3:E 4:N 5:R 6:S 7:B
//*              j       1ŗړ_⏞L
//*              bd      1ŒfmL
//*              bf      fm̑l 0:800000 1:7FFFFF
//***************************************************************************
DECLSPEC LALanioSetTC(hLANIO handle, int ch, int tc_type, int j, int bd, int bf);

//***************************************************************************
//*     LANIO̔MdΑΌo͂ݒ肵܂
//*        : handle         LANIOnh
//*              ch             `lw肵܂B 0:AI1 1:AI2 ...
//*              range          Όo̓W
//*                             0:0-10V 1:0-5V 2:1-5V 3:4-20mA
//*              scale_lowest   XP[ݒ
//*              scale_highest  XP[ݒ
//***************************************************************************
DECLSPEC LALanioSetTCnotice(hLANIO handle, int ch, int range, int scale_lowest, int scale_highest);

//***************************************************************************
//*     LANIO̔MdΑݒ擾܂
//*        : handle  LANIOnh
//*              ch             `lw肵܂B 0:AI1 1:AI2 ...
//*              tc_type        Md΂̃^Cvw
//*                             0:K 1:J 2:T 3:E 4:N 5:R 6:S 7:B
//*              j              1ŗړ_⏞L
//*              bd             1ŒfmL
//*              bf             fm̑l 0:800000 1:7FFFFF
//*              range          Όo̓W
//*                             0:0-10V 1:0-5V 2:1-5V 3:4-20mA
//*              scale_lowest   XP[ݒ
//*              scale_highest  XP[ݒ
//***************************************************************************
DECLSPEC LALanioGetTC(hLANIO handle, int ch, int *tc_type, int *j, int *bd, int *bf, int *range, int *scale_lowest, int *scale_highest);

//***************************************************************************
//*     DOA[gݒ肵܂
//*        : handle  LANIOnh
//*              do_ch   `lw肵܂B 0:DO1 1:DO2 ...
//*              ai_ch   ̓`lw肵܂B 0:AI1 1:AI2 ...
//*              hd      qXeVXw 0:LED̈D 1:LED_̈D
//*              width   qXeVX
//***************************************************************************
DECLSPEC LALanioSetDOAlart(hLANIO handle, int do_ch, int ai_ch, int hd, int width);

//***************************************************************************
//*     DOA[gJn/~ݒ肵܂
//*        : handle  LANIOnh
//*              do_ch   `lw肵܂B 0:DO1 1:DO2 ...
//*              start   0Œ~ 1ŊJn
//***************************************************************************
DECLSPEC LALanioStartStopDOAlart(hLANIO handle, int do_ch, int start);

//***************************************************************************
//*     DOA[gݒ擾܂
//*        : handle  LANIOnh
//*              do_ch   `lw肵܂B 0:DO1 1:DO2 ...
//*              start   0Œ~ 1ŊJn
//*              ai_ch   ̓`lw肵܂B 0:AI1 1:AI2 ...
//*              hd      qXeVXw 0:LED̈D 1:LED_̈D
//*              width   qXeVX
//***************************************************************************
DECLSPEC LALanioGetDOAlart(hLANIO handle, int do_ch, int *start, int *ai_ch, int *hd, int *width);
